/*
 * common.h
 *
 * Created: 2019/04/25 19:47:33
 *  Author: mNEFO
 */ 

#ifndef COMMON_H_
#define COMMON_H_

#define CHARNUM_TO_NUM(C) (C -= 48)
/* PORT C is nixie cathode.
** PC0 OUT PD NIXIE a segment
** PC1 OUT PD NIXIE b segment
** PC2 OUT PD NIXIE f segment
** PC3 OUT PD NIXIE g segment
** PC4 OUT PD NIXIE c segment
** PC5 OUT PD NIXIE e segment
** PC6 OUT PD NIXIE d segment
** PC7 NC
*/
//                                                  decgfba
#define NIXIE_OUTPUT_0 (NIXIE_CATHODE_NUM_PORT = 0b01110111)
#define NIXIE_OUTPUT_1 (NIXIE_CATHODE_NUM_PORT = 0b00010010)
#define NIXIE_OUTPUT_2 (NIXIE_CATHODE_NUM_PORT = 0b01101011)
#define NIXIE_OUTPUT_3 (NIXIE_CATHODE_NUM_PORT = 0b01011011)
#define NIXIE_OUTPUT_4 (NIXIE_CATHODE_NUM_PORT = 0b00011110)
#define NIXIE_OUTPUT_5 (NIXIE_CATHODE_NUM_PORT = 0b01011101)
#define NIXIE_OUTPUT_6 (NIXIE_CATHODE_NUM_PORT = 0b01111101)
#define NIXIE_OUTPUT_7 (NIXIE_CATHODE_NUM_PORT = 0b00010111)
#define NIXIE_OUTPUT_8 (NIXIE_CATHODE_NUM_PORT = 0b01111111)
#define NIXIE_OUTPUT_9 (NIXIE_CATHODE_NUM_PORT = 0b01011111)
#define NIXIE_OUTPUT_N (NIXIE_CATHODE_NUM_PORT = 0b00000000) // suppress

void wait_ms(uint16_t t);
void wait_us(uint16_t t);
void on_gps_led(void);
void off_gps_led(void);
void toggle_gps_led(void);
void start_gps(void);
void stop_gps(void);
void reset_gps(void);
void on_hvps(void);
void off_hvps(void);
void init_duty(void);
void normal_duty(void);
void minimum_duty(void);
void show_op_time(void);
void reset_all_setting(void);
uint8_t rand_xor_shift(void);
uint8_t get_monthend(uint8_t century, uint8_t year, uint8_t month);
uint8_t get_zeller_day(uint8_t century, uint8_t year, uint8_t month, uint8_t date);

#endif /* COMMON_H_ */