/*
 * config.h
 *
 * Created: 2019/04/25 9:23:13
 *  Author: mNEFO
 */ 

#ifndef CONFIG_H_
#define CONFIG_H_

// ZM1500 number of digits
#define DIGIT_NUM 12

// Nixie duty
#define DUTY_CYCLE 180
#define DUTY_MAX 100
#define DUTY_NORMAL 60
#define DUTY_MIN 5

// Nixie anode
#define NIXIE_ANODE_PORT_0 PORTA // 1-8
#define NIXIE_ANODE_PORT_1 PORTF // 9-12
#define NIXIE_ANODE_DVIDE 8

// Nixie cathode
#define NIXIE_CATHODE_NUM_PORT PORTC
#define NIXIE_CATHODE_MASK 0b10000000
#define NIXIE_CATHODE_SUPPRESS 10
#define NIXIE_CATHODE_HYPHEN 11

// Nixie cathode dot
#define NIXIE_CATHODE_DP_DOT OCR1B
#define NIXIE_CATHODE_UP_DOT OCR1C

// Light sensor
#define LIGHT_SENSOR_PIN 7
#define LIGHT_SENSOR_TH_MAX 900
#define LIGHT_SENSOR_TH_MIN 0

// GPS status LED
#define GPS_LED_PORT PORTG
#define GPS_LED PG0

// GPS power
#define GPS_PS_PORT PORTE
#define GPS_PS      PE2

// HVPS
#define HVPS_SW_PORT PORTE
#define HVPS_SW      PE3

// Encoder
#define ENC_A_PIN  PD5
#define ENC_SW_PIN PD6
#define ENC_B_PIN  PD7
#define ENC_PORT   PIND

// Long push counts
#define LONG_PUSH_COUNT 500

// mode: NORMAL or SETTING
// uint8_t global_mode
#define MODE_NORMAL  0
#define MODE_SETTING 1

// mode NOMAL
// global_config_data.mode (eeprom)
#define MODE_NORMAL_YMDT         0 // year month date time
#define MODE_NORMAL_MDTS         1 // month date time second

// mode SETTING
#define MODE_SETTING_DUTY     0
#define MODE_SETTING_LIGHT    1
#define MODE_SETTING_LIGHT_TH 2
#define MODE_SETTING_LIGHT_PW 3
#define MODE_SETTING_GPS      4
#define MODE_SETTING_GPS_LOG  5
#define MODE_SETTING_GPS_TZ   6

// config mode
#define CONFIG_NONE   0
#define CONFIG_ENABLE 1

/* Boolean type */
typedef enum{FALSE = 0, TRUE = 1} BOOL;
typedef enum{DISABLE = 0, ENABLE = 1} SWITCH;
typedef enum{UP = 0, DOWN = 1} PWM_DIRECTION;
typedef enum{RANDOM = 0, PATTERN = 1, MANUAL = 2} TEST_PATTERN;

// dot mode
#define DOT_PWM   0
#define DOT_BLINK 1
#define DOT_ON    2
#define DOT_OFF   3
#define DOT_END   4

// dot PWM
#define DOT_PWM_MAX 250
#define DOT_PWM_MIN 4

// current mode
#define CURRENT_MODE global_config_data.mode

// operation time
#define SEC_UPDATE_COUNT     2*2*60*60            // by 2hour(2 clock/sec)
#define SEC_UPDATE_INCREMENT (SEC_UPDATE_COUNT/2)

// for xor shift seed
#define XOR_SHIFT_SEED 39 // mikudayo-

#endif /* CONFIG_H_ */