/*
 * eeprom.h
 *
 * Created: 2019/04/25 9:22:02
 *  Author: mNEFO
 */ 

#ifndef EEPROM_H_
#define EEPROM_H_

#include "config.h"

typedef struct _config_data{
	volatile uint8_t mode;
	volatile uint8_t century;
	volatile uint8_t duty;
	volatile uint8_t dot_mode;
	volatile uint32_t sec_count;
	volatile uint8_t use_light_sensor;
	volatile uint16_t light_sensor_th;
	volatile uint8_t light_sensor_hvps;
	volatile uint8_t use_gps;
	volatile uint8_t gps_log;
	volatile int8_t  gps_tz;
	volatile uint32_t serial;
}CONFIG_DATA;

#define E_MODE_DEFAULT               MODE_NORMAL_YMDT
#define E_CENTURY_DEFAULT            20
#define E_NIXIE_DUTY_DEFAULT         DUTY_NORMAL
#define E_DOT_MODE_DEFAULT           DOT_PWM
#define E_SEC_COUNT_DEFAULT          0
#define E_USE_LIGHT_SENSOR_DEFAULT   ENABLE
#define E_LIGHT_SENSOR_TH_DEFAULT    100
#define E_LIGHT_SENSOR_HVPS_DEFAULT  DISABLE
#define E_USE_GPS_DEFAULT            ENABLE
#define E_USE_GPS_LOG_DEFAULT        DISABLE
#define E_GPS_TIMEZONE_DEFAULT       9 // japan

void read_eeprom_setting(void);
void reset_eeprom_setting(void);
void eep_update_mode(uint8_t mode);
void eep_update_century(uint8_t century);
void eep_update_duty(uint8_t duty);
void eep_toggle_dot_mode(void);
void eep_update_dot_mode(uint8_t dot_mode);
void eep_update_sec_count(uint32_t sec_count);
void eep_update_use_light_sensor(uint8_t use_light_sensor);
void eep_update_light_sensor_th(uint16_t light_sensor_th);
void eep_update_light_sensor_hvps(uint8_t light_sensor_hvps);
void eep_update_use_gps(uint8_t use_gps);
void eep_update_gps_log(uint8_t gps_log);
void eep_update_gps_tz(int8_t gps_tz);
void eep_update_serial(uint32_t serial);

#endif /* EEPROM_H_ */