/*
 * uart.h
 *
 * Created: 2019/05/06 13:55:06
 *  Author: mNEFO
 */ 

#ifndef UART_H_
#define UART_H_

// GPS(and uart) power
#define GPS_PS_PORT PORTE
#define GPS_PS      PE2

// uart buffer
#define UART_BUF 512
#define LINE_BUF 256

// Xmodem
#define _SOH 0x01
#define _STX 0x02
#define _EOT 0x04
#define _ACK 0x06
#define _NAK 0x15
#define _CAN 0x18
#define _EOF 0x1a
#define _XYN _NAK
#define _XYC 'C'
#define _XYG 'G'
#define XMODEM_DATA_SIZE 128
#define XMODEM_DATA_START 3 // global_Xmodem_buf[3]
#define XMODEM_DATA_END (XMODEM_DATA_START + XMODEM_DATA_SIZE - 1)  // global_Xmodem_buf[130]
#define XMODEM_CHECKSUM (global_Xmodem_buf[131])
#define XMODEM_BLOCK_SIZE (XMODEM_DATA_SIZE + 4)
#define XMODEM_BLOCK_DATA_NUM global_Xmodem_buf[1]
#define XMODEM_BLOCK_DATA_NUM_COMP global_Xmodem_buf[2]
// Xmodem data number starts 1. And overflow 255->0
#define XMODEM_BLOCK_NUM_START 1
#define XMODEM_BLOCK_NUM_MAX 255

void init_uart(void);
//void uart0_put(uint8_t data);
//void uart0_putn(uint8_t data);
void uart1_put(uint8_t data);
void uart1_putn(uint8_t data);

#endif /* UART_H_ */